
// QTreeCanvas: a QCanvas which fills itself with items representing
// a FileLogCache. 

class QTreeCanvas : public QCanvas  
{
public:
	QTreeCanvas
		( QWidget* parent, char* file, ClientApi* client, Error* error, 
		  bool jobs, bool trunc, QString cs, QString ds, QString end, bool all,
		  char* cfile );
	virtual ~QTreeCanvas();

	// Slide the FileTexts over to xcoord. 
	void UpdateFTexts( int xcoord );

	// Did something go wrong during construction? 
	bool IsEmpty() { 
		return ( !cache->main || 
				 !cache->changes ||
				 !cache->changes->Size() ); } ;

	// Size of the changebar and jobbar. 
	QSize ChangeSize();

	// Set colors according to current color scheme.
	void UpdateColors();

	// Show or hide the gridline.
	void GridLine( int x );

	FileLogCache* cache;
private:
	void InitNormalArrows();
	void InitTruncArrows();

	void NameSort();

	ClientApi* client;
	Error* error;
	char* cachefile;
	QTreeChangeBar* changebar;
	QTreeJobBar* jobbar;
	QTreeFileStripe** filestripes;
	QTreeArrow** arrows;
	QCanvasLine* gridline;
};

