
// QTreeFileDialog: a small dialog displaying a bit of
// info about a depot file. 

#ifndef QTREEFILEDIALOG_H

#include <clientapi.h>
#include <qdialog.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qprocess.h>
#include <qpushbutton.h>
#include <qsettings.h>

#include "changesorter.h"
#include "filehead.h"
#include "filelogcache.h"

#endif // QTREEFILEDIALOG_H

class QTreeFileDialog : public QDialog  
{
	Q_OBJECT
public:
	QTreeFileDialog( QWidget* parent, FileHead* file );
	virtual ~QTreeFileDialog();

public slots:
	// Invoke P4Win's Revision History. 
	void RevHistory();

private:
	FileHead* fh;

	QLabel* filename;

	QLabel* filetype;

	QLabel* created;

	QLabel* modified;

	QPushButton* ok;
	QHBoxLayout* oklayout;

	QPushButton* revhist;

	QVBoxLayout* mainlayout;
};
